﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;
using System.Collections;

namespace StackOverFlowTest
{
    public partial class Form1 : Form
    {
        sortGroupByHelper gbh = new sortGroupByHelper();

        public Form1()
        {
            InitializeComponent();
        }

        protected override void OnLoad(EventArgs e)
        {
            base.OnLoad(e);

            // Build table
            DataTable tbl = new DataTable("Table");
            tbl.Columns.Add("Issuer", typeof(string));
            tbl.Columns.Add("ParentCompany", typeof(string));
            tbl.Columns.Add("PM", typeof(string));
            tbl.Columns.Add("Val", typeof(double));

            // Fill dummy data
            for (int i = 0; i < 100; i++)
            {
                tbl.Rows.Add((i / 10).ToString(), i.ToString(), (i / 100).ToString(), 1000000 - i);
                tbl.Rows.Add((i / 10).ToString(), i.ToString(), (i / 100).ToString(), (double)i);
            }

            ultraGrid1.DataSource = tbl;

            ultraGrid1.DisplayLayout.Bands[0].Columns["Issuer"].GroupByComparer = gbh;
            ultraGrid1.DisplayLayout.Bands[0].Columns["ParentCompany"].GroupByComparer = gbh;
            ultraGrid1.DisplayLayout.Bands[0].Columns["PM"].GroupByComparer = gbh;
            ultraGrid1.DisplayLayout.Bands[0].Columns["Val"].GroupByComparer = gbh;
        }

        public class sortGroupByHelper : IComparer
        {
            public int Compare(object x, object y)
            {
                Infragistics.Win.UltraWinGrid.UltraGridGroupByRow xg = (Infragistics.Win.UltraWinGrid.UltraGridGroupByRow)(x);
                return xg.Description.CompareTo(((Infragistics.Win.UltraWinGrid.UltraGridGroupByRow)(y)).Description.ToString());
            }
        }

    }
}
